[NOI2010]航空管制 题解
题目地址:洛谷:【P1954】[NOI2010]航空管制 – 洛谷、BZOJ:Problem 2535. — [Noi2010]Plane 航空管制2
题目描述
世博期间,上海的航空客运量大大超过了平时,随之而来的航空管制也频频发生。最近,小X就因为航空管制,连续两次在机场被延误超过了两小时。对此,小X表示很不满意。
在这次来烟台的路上,小X不幸又一次碰上了航空管制。于是小X开始思考关于航空管制的问题。
假设目前被延误航班共有n个,编号为1至n。机场只有一条起飞跑道,所有的航班需按某个顺序依次起飞(称这个顺序为起飞序列)。定义一个航班的起飞序号为该航班在起飞序列中的位置,即是第几个起飞的航班。
起飞序列还存在两类限制条件:
- 第一类(最晚起飞时间限制):编号为i的航班起飞序号不得超过ki;
- 第二类(相对起飞顺序限制):存在一些相对起飞顺序限制(a, b),表示航班a的起飞时间必须早于航班b,即航班a的起飞序号必须小于航班b的起飞序号。
小X思考的第一个问题是,若给定以上两类限制条件,是否可以计算出一个可行的起飞序列。第二个问题则是,在考虑两类限制条件的情况下,如何求出每个航班在所有可行的起飞序列中的最小起飞序号。
输入输出格式
输入格式:
输入文件plane.in第一行包含两个正整数n和m,n表示航班数目,m表示第二类限制条件(相对起飞顺序限制)的数目。
第二行包含n个正整数k1, k2, …, kn。
接下来m行,每行两个正整数a和b,表示一对相对起飞顺序限制(a, b),其中1≤a,b≤n, 表示航班a必须先于航班b起飞。
输出格式:
输出文件plane.out由两行组成。
第一行包含n个整数,表示一个可行的起飞序列,相邻两个整数用空格分隔。输入数据保证至少存在一个可行的起飞序列。如果存在多个可行的方案,输出任意一个即可。
第二行包含n个整数t1, t2, …, tn,其中ti表示航班i可能的最小起飞序号,相邻两个整数用空格分隔。
输入输出样例
输入样例#1:
5 5 4 5 2 5 4 1 2 3 2 5 1 3 4 3 1
输出样例#1:
3 5 1 4 2 3 4 1 2 1
输入样例#2:
5 0 3 3 3 5 5
输出样例#2:
3 2 1 5 4 1 1 1 4 4
说明
【样例说明】
在样例1 中:
起飞序列3 5 1 4 2满足了所有的限制条件,所有满足条件的起飞序列有:
3 4 5 1 2 3 5 1 2 4 3 5 1 4 2 3 5 4 1 2
5 3 1 2 4 5 3 1 4 2 5 3 4 1 2
由于存在(5, 1)和(3, 1)两个限制,航班1只能安排在航班5和3之后,故最早起飞时间为3,其他航班类似。
在样例2 中:
虽然航班4、5没有相对起飞顺序限制,但是由于航班1、2、3都必须安排在前3个起飞,所以4、5最早只能安排在第4个起飞。
【数据范围】
对于30%数据:n≤10;
对于60%数据:n≤500;
对于100%数据:n≤2,000,m≤10,000。
题解
第一问,考虑把限制条件建个图,一定是一个DAG,直接进行拓扑排序,只不过拓扑的队列要改成优先队列,优先级按最晚时间限制从小到大排序,这样出来的顺序就是正确的了。
但是考虑第二问的时候,发现就算建反图DFS还可能出现其他需要满足的条件,例如样例2中前三个飞机必须在前三飞。此时我们考虑倒着找,建反图按限制从大到小的顺序拓扑,我们枚举每个飞机u,每次都拓扑一遍,遇到u的时候直接把它设置为不可以被加入队列中,这样就可以无视掉u的前置,直到条件不能被满足位置。倒着拓扑的意义,实质上是在求满足了u以后剩下最多的点。用n减去这个数字就得到了我们想要的答案。
这个做法的复杂度是O(n^2 \log n)的,在洛谷得开O2才能跑过。
代码
// Code by KSkun, 2018/5
#include <cstdio>
#include <cctype>
#include <cstring>
#include <algorithm>
#include <queue>
#include <vector>
typedef long long LL;
inline char fgc() {
static char buf[100000], *p1 = buf, *p2 = buf;
return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2) ? EOF
: *p1++;
}
inline LL readint() {
register LL res = 0, neg = 1;
register char c = fgc();
while(!isdigit(c)) {
if(c == '-') neg = -1;
c = fgc();
}
while(isdigit(c)) {
res = (res << 1) + (res << 3) + c - '0';
c = fgc();
}
return res * neg;
}
const int MAXN = 20005;
std::vector<int> gra[MAXN];
int deg[MAXN];
inline void addedge(int u, int v) {
gra[u].push_back(v); deg[v]++;
}
int n, m, lim[MAXN];
struct Node {
int u, lim;
inline bool operator<(const Node &rhs) const {
return lim < rhs.lim;
}
};
int now[MAXN];
int ans[MAXN];
inline void toposort() {
std::priority_queue<Node> pq;
memcpy(now, deg, sizeof(deg));
for(int i = 1; i <= n; i++) {
if(!now[i]) pq.push(Node {i, lim[i]});
}
int cnt = n;
while(!pq.empty()) {
int u = pq.top().u; pq.pop();
ans[cnt--] = u;
for(int i = 0; i < gra[u].size(); i++) {
int v = gra[u][i];
if(!--now[v]) {
pq.push(Node {v, lim[v]});
}
}
}
}
inline int toposort1(int uu) {
std::priority_queue<Node> pq;
memcpy(now, deg, sizeof(deg));
now[uu] = n;
for(int i = 1; i <= n; i++) {
if(!now[i]) pq.push(Node {i, lim[i]});
}
for(int i = n; i; i--) {
if(pq.empty() || pq.top().lim < i) return i;
int u = pq.top().u; pq.pop();
for(int i = 0; i < gra[u].size(); i++) {
int v = gra[u][i];
if(!--now[v]) pq.push(Node {v, lim[v]});
}
}
}
int main() {
n = readint(); m = readint();
for(int i = 1; i <= n; i++) {
lim[i] = readint();
}
for(int i = 1, u, v; i <= m; i++) {
u = readint(); v = readint();
addedge(v, u);
}
toposort();
for(int i = 1; i <= n; i++) {
printf("%d ", ans[i]);
}
printf("\n");
for(int i = 1; i <= n; i++) {
printf("%d ", toposort1(i));
}
return 0;
}
同性交友,排解寂寞,释放压力,尽在https://luogu.org